QuattroSpreadsheet Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
QuattroSpreadsheet Class Reference

This class parses Quattro Pro DOS spreadsheet file. More...

`#include <QuattroSpreadsheet.h>`

## Public Member Functions
| QuattroSpreadsheet (QuattroParser &parser)
| constructor More...
| ~QuattroSpreadsheet ()
| destructor More...
void | setListener (WKSContentListenerPtr &listen)
| sets the listener More...

## Protected Member Functions
bool | checkFilePosition (long pos)
| return true if the pos is in the file, update the file size if need More...
int | version () const
| return the file version More...
bool | hasLICSCharacters () const
| returns the true if the file has LICS characters More...
int | getNumSpreadsheets () const
| returns the number of spreadsheet More...
void | sendSpreadsheet (int sId)
| send the sId'th spreadsheet More...
void | sendCellContent (QuattroSpreadsheetInternal::Cell const &cell)
| send the cell data More...
bool | readSpreadsheetOpen ()
| reads a sheet header zone 0:dc (Quattro Pro wq2) More...
bool | readSpreadsheetClose ()
| reads a sheet header zone 0:dd (Quattro Pro wq2) More...
bool | readCell ()
| reads a cell content data More...
bool | readCellFormulaResult ()
| reads the result of a text formula More...
bool | readSheetSize ()
| reads sheet size More...
bool | readSpreadsheetName ()
| reads a sheet name (zone 0xde), unused... More...
bool | readColumnSize ()
| reads the column size ( in ??? ) More...
bool | readRowSize ()
| reads the column size ( in points ) More...
bool | readHiddenColumns ()
| reads the list of hidden columns zone ( unused ) More...
bool | readCellProperty ()
| reads a Quattro Pro property (zone 0x9d) More...
bool | readCellStyle ()
| reads a Quattro Pro cell styles (zone 0xd8) More...
bool | readUserStyle ()
| reads a Quattro Pro style ( zone 0xc9) More...
bool | readCell (Vec2i actPos, WKSContentListener::FormulaInstruction &instr, bool hasSheetId=false, int sheetId=0)
bool | readFormula (long endPos, Vec2i const &pos, int sheetId, std::vector< WKSContentListener::FormulaInstruction > &formula, std::string &error)

## Private Member Functions
| QuattroSpreadsheet (QuattroSpreadsheet const &orig)
QuattroSpreadsheet & | operator= (QuattroSpreadsheet const &orig)
libwps::DebugFile & | ascii ()
| returns the debug file More...

## Private Attributes
RVNGInputStreamPtr | m_input
| the input More...
shared_ptr< WKSContentListener > | m_listener
QuattroParser & | m_mainParser
| the listener (if set) More...
shared_ptr< QuattroSpreadsheetInternal::State > | m_state
| the internal state More...
libwps::DebugFile & | m_asciiFile
| the ascii file More...

## Friends
class | QuattroParser

## Detailed Description

This class parses Quattro Pro DOS spreadsheet file.

## Constructor & Destructor Documentation

QuattroSpreadsheet::QuattroSpreadsheet | ( | QuattroParser & | parser | ) |
| explicit

constructor

QuattroSpreadsheet::~QuattroSpreadsheet | ( |  | ) |

destructor

QuattroSpreadsheet::QuattroSpreadsheet | ( | QuattroSpreadsheet const & | orig | ) |
| private

## Member Function Documentation

libwps::DebugFile& QuattroSpreadsheet::ascii | ( |  | ) |
| inlineprivate

returns the debug file

Referenced by readCell(), readCellFormulaResult(), readCellProperty(), readCellStyle(), readColumnSize(), readFormula(), readHiddenColumns(), readRowSize(), readSheetSize(), readSpreadsheetClose(), readSpreadsheetName(), readSpreadsheetOpen(), and readUserStyle().

bool QuattroSpreadsheet::checkFilePosition | ( | long | pos | ) |
| protected

return true if the pos is in the file, update the file size if need

int QuattroSpreadsheet::getNumSpreadsheets | ( |  | ) | const
| protected

returns the number of spreadsheet

bool QuattroSpreadsheet::hasLICSCharacters | ( |  | ) | const
| protected

returns the true if the file has LICS characters

Referenced by sendCellContent().

QuattroSpreadsheet& QuattroSpreadsheet::operator= | ( | QuattroSpreadsheet const & | orig | ) |
| private

bool QuattroSpreadsheet::readCell | ( |  | ) |
| protected

reads a cell content data

Referenced by readFormula(), and readSpreadsheetClose().

bool QuattroSpreadsheet::readCell | ( | Vec2i | actPos,
|  | WKSContentListener::FormulaInstruction & | instr,
|  | bool | hasSheetId = `false`,
|  | int | sheetId = `0`
| ) |  |
| protected

bool QuattroSpreadsheet::readCellFormulaResult | ( |  | ) |
| protected

reads the result of a text formula

bool QuattroSpreadsheet::readCellProperty | ( |  | ) |
| protected

reads a Quattro Pro property (zone 0x9d)

bool QuattroSpreadsheet::readCellStyle | ( |  | ) |
| protected

reads a Quattro Pro cell styles (zone 0xd8)

bool QuattroSpreadsheet::readColumnSize | ( |  | ) |
| protected

reads the column size ( in ??? )

bool QuattroSpreadsheet::readFormula | ( | long | endPos,
|  | Vec2i const & | pos,
|  | int | sheetId,
|  | std::vector< WKSContentListener::FormulaInstruction > & | formula,
|  | std::string & | error
| ) |  |
| protected

Referenced by readCell().

bool QuattroSpreadsheet::readHiddenColumns | ( |  | ) |
| protected

reads the list of hidden columns zone ( unused )

bool QuattroSpreadsheet::readRowSize | ( |  | ) |
| protected

reads the column size ( in points )

bool QuattroSpreadsheet::readSheetSize | ( |  | ) |
| protected

reads sheet size

bool QuattroSpreadsheet::readSpreadsheetClose | ( |  | ) |
| protected

reads a sheet header zone 0:dd (Quattro Pro wq2)

bool QuattroSpreadsheet::readSpreadsheetName | ( |  | ) |
| protected

reads a sheet name (zone 0xde), unused...

bool QuattroSpreadsheet::readSpreadsheetOpen | ( |  | ) |
| protected

reads a sheet header zone 0:dc (Quattro Pro wq2)

bool QuattroSpreadsheet::readUserStyle | ( |  | ) |
| protected

reads a Quattro Pro style ( zone 0xc9)

void QuattroSpreadsheet::sendCellContent | ( | QuattroSpreadsheetInternal::Cell const & | cell | ) |
| protected

send the cell data

Referenced by sendSpreadsheet().

void QuattroSpreadsheet::sendSpreadsheet | ( | int | sId | ) |
| protected

send the sId'th spreadsheet

void QuattroSpreadsheet::setListener | ( | WKSContentListenerPtr & | listen | ) |
| inline

sets the listener

int QuattroSpreadsheet::version | ( |  | ) | const
| protected

return the file version

Referenced by readCell(), readCellFormulaResult(), readCellStyle(), readFormula(), and readUserStyle().

## Friends And Related Function Documentation

friend class QuattroParser
| friend

## Member Data Documentation

libwps::DebugFile& QuattroSpreadsheet::m_asciiFile
| private

the ascii file

RVNGInputStreamPtr QuattroSpreadsheet::m_input
| private

the input

Referenced by checkFilePosition(), readCell(), readCellFormulaResult(), readCellProperty(), readCellStyle(), readColumnSize(), readFormula(), readHiddenColumns(), readRowSize(), readSheetSize(), readSpreadsheetClose(), readSpreadsheetName(), readSpreadsheetOpen(), readUserStyle(), and sendCellContent().

shared_ptr<WKSContentListener> QuattroSpreadsheet::m_listener
| private

Referenced by sendCellContent(), and sendSpreadsheet().

QuattroParser& QuattroSpreadsheet::m_mainParser
| private

the listener (if set)

the main parser

Referenced by hasLICSCharacters(), readCell(), readCellProperty(), readCellStyle(), readUserStyle(), and version().

shared_ptr<QuattroSpreadsheetInternal::State> QuattroSpreadsheet::m_state
| private

the internal state

Referenced by checkFilePosition(), getNumSpreadsheets(), hasLICSCharacters(), QuattroSpreadsheet(), readCell(), readCellProperty(), readCellStyle(), readColumnSize(), readRowSize(), readSheetSize(), readSpreadsheetClose(), readSpreadsheetOpen(), readUserStyle(), sendSpreadsheet(), and version().

The documentation for this class was generated from the following files:

- QuattroSpreadsheet.h
- QuattroSpreadsheet.cpp